package com.ruoyi.record.service.impl;

import java.io.File;
import java.util.List;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.file.Files;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ruoyi.common.config.RuoYiConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.FileSystemResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import com.ruoyi.record.mapper.RecordInspectionCabinetMapper;
import com.ruoyi.record.domain.RecordInspectionCabinet;
import com.ruoyi.record.service.IRecordInspectionCabinetService;

/**
 * 电柜巡检记录Service业务层处理
 *
 * @author zangch
 * @date 2024-11-07
 */
@Service
public class RecordInspectionCabinetServiceImpl implements IRecordInspectionCabinetService
{
    @Autowired
    private RecordInspectionCabinetMapper recordInspectionCabinetMapper;

    /**
     * 查询电柜巡检记录
     *
     * @param objId 电柜巡检记录主键
     * @return 电柜巡检记录
     */
    @Override
    public RecordInspectionCabinet selectRecordInspectionCabinetByObjId(Long objId)
    {
        return recordInspectionCabinetMapper.selectRecordInspectionCabinetByObjId(objId);
    }

    /**
     * 查询电柜巡检记录列表
     *
     * @param recordInspectionCabinet 电柜巡检记录
     * @return 电柜巡检记录
     */
    @Override
    public List<RecordInspectionCabinet> selectRecordInspectionCabinetList(RecordInspectionCabinet recordInspectionCabinet)
    {
        return recordInspectionCabinetMapper.selectRecordInspectionCabinetList(recordInspectionCabinet);
    }

    /**
     * 新增电柜巡检记录
     *
     * @param recordInspectionCabinet 电柜巡检记录
     * @return 结果
     */
    @Override
    public int insertRecordInspectionCabinet(RecordInspectionCabinet recordInspectionCabinet)
    {
        return recordInspectionCabinetMapper.insertRecordInspectionCabinet(recordInspectionCabinet);
    }

    /**
     * 修改电柜巡检记录
     *
     * @param recordInspectionCabinet 电柜巡检记录
     * @return 结果
     */
    @Override
    public int updateRecordInspectionCabinet(RecordInspectionCabinet recordInspectionCabinet)
    {
        return recordInspectionCabinetMapper.updateRecordInspectionCabinet(recordInspectionCabinet);
    }

    /**
     * 批量删除电柜巡检记录
     *
     * @param objIds 需要删除的电柜巡检记录主键
     * @return 结果
     */
    @Override
    public int deleteRecordInspectionCabinetByObjIds(Long[] objIds)
    {
        return recordInspectionCabinetMapper.deleteRecordInspectionCabinetByObjIds(objIds);
    }

    /**
     * 删除电柜巡检记录信息
     *
     * @param objId 电柜巡检记录主键
     * @return 结果
     */
    @Override
    public int deleteRecordInspectionCabinetByObjId(Long objId)
    {
        return recordInspectionCabinetMapper.deleteRecordInspectionCabinetByObjId(objId);
    }

    /**
     * 获取热成像视频文件。
     * @param filePath 需要获取的视频文件的路径。
     * @return 如果文件存在，返回包含文件资源的响应实体；如果文件不存在，返回404状态。
     */
    @Override
    public ResponseEntity<FileSystemResource> getThermalVideo(String filePath){
        // 获取配置文件中的路径application.yml的profile
        String myPath = RuoYiConfig.getMyPath();
        // 构建完整的文件路径
        String fileUrl = myPath + "/日志信息/巡检录像/热成像/" + filePath;
        // 创建文件对象
        File file = new File(fileUrl);
        // 检查文件是否存在
        if (file.exists()) {
            // 创建文件系统资源对象，包装文件，http头不能使用file，所以使用FileSystemResource
            FileSystemResource resource = new FileSystemResource(file);
            // 设置响应头，指定内容类型为视频格式
            HttpHeaders headers = new HttpHeaders();
            // 设置文件长度的内容类型
            headers.setContentLength(file.length());
            // 动态检测文件的MIME类型
            try {
                String contentType = Files.probeContentType(file.toPath());
                if (contentType != null) {
                    headers.setContentType(MediaType.parseMediaType(contentType));
                } else {
                    headers.setContentType(MediaType.parseMediaType("video/*"));
                }
            } catch (IOException e) {
                headers.setContentType(MediaType.parseMediaType("video/*"));
            }
            // 返回包含文件资源的响应实体
            return ResponseEntity.ok()
                    .headers(headers)
                    .body(resource);
        } else {
            // 如果文件不存在，返回404状态
            return ResponseEntity.notFound().build();
        }
    }

    /**
     * 获取可见光视频文件。
     * @param filePath 需要获取的视频文件的路径。
     * @return 如果文件存在，返回包含文件资源的响应实体；如果文件不存在，返回404状态。
     */
    @Override
    public ResponseEntity<FileSystemResource> getVisibleVideo(String filePath){
        // 获取配置文件中的路径application.yml的profile
        String myPath = RuoYiConfig.getMyPath();
        // 构建完整的文件路径
        String fileUrl = myPath + "/日志信息/巡检录像/可见光/" + filePath;
        // 创建文件对象
        File file = new File(fileUrl);
        // 检查文件是否存在
        if (file.exists()) {
            // 创建文件系统资源对象，包装文件，http头不能使用file，所以使用FileSystemResource
            FileSystemResource resource = new FileSystemResource(file);
            // 设置HTTP头信息
            HttpHeaders headers = new HttpHeaders();
            // 设置文件长度
            headers.setContentLength(file.length());
            // 动态检测文件的MIME类型
            try {
                String contentType = Files.probeContentType(file.toPath());
                if (contentType != null) {
                    headers.setContentType(MediaType.parseMediaType(contentType));
                } else {
                    headers.setContentType(MediaType.parseMediaType("video/*"));
                }
            } catch (IOException e) {
                headers.setContentType(MediaType.parseMediaType("video/*"));
            }
            // 返回包含文件资源的响应实体
            return ResponseEntity.ok()
                    .headers(headers)
                    .body(resource);
        } else {
            // 如果文件不存在，返回404状态
            return ResponseEntity.notFound().build();
        }
    }

}
